*+--------------------------------------------------------------------
*+
*+ Source Module => d:\ALASKA\PDF\\DEMO2.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Appsys()
*+               Procedure Main()
*+               Procedure LoadFile()
*+               Function Pathonly()
*+               Function Fileonly()
*+               Procedure DoResize()
*+
*+    Reformatted by Click! 2.05.30 on Mar-15-2020 at  2:30 am
*+
*+--------------------------------------------------------------------

#include "Xbp.ch"
#include "Appevent.ch"

#pragma library("XppUi2")                        // for XbpFileDialog()

*+--------------------------------------------------------------------
*+
*+    Procedure Appsys()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Appsys
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oFileDlg, cPdfFile := ""
LOCAL oDlg, cPanel, oStatic, aSize
LOCAL oSumatra
LOCAL lExit    := .F.
LOCAL cDir, aDir, ii, iMax, oPb2
LOCAL aFilters := { { "PDF Files", "*.PDF" }, ;
                       { "all Files", "*.*" } }

   oFileDlg := XbpFileDialog() :new()
   oFileDlg:create( AppDesktop() )
   oFileDlg:fileFilters := aFilters

   cPdfFile := oFileDlg:open()

   IF !EMPTY( cPdfFile )

      cPanel := Fileonly( cPdfFile )
      cDir := STRTRAN( cPdfFile, cPanel, "" )
      aDir := DIRECTORY( cDir + "*.PDF" )
      iMax := LEN( aDir )

      oDlg := XbpDialog() :new(,, { 0, 0 }, { 1280, 1024 } )
      oDlg:title := cPanel
      oDlg:taskList := .T.
      oDlg:close := { || lExit := .T. }
      oDlg:DrawingArea:resize := { | aOldSize, aNewSize, oSelf | DoResize( aOldSize, aNewSize, oSelf, oSumatra ) }
      oDlg:create()

      CenterControl( oDlg )
      aSize := oDlg:clientsize
      aSize[ 2 ] -= 24

      oStatic := XbpStatic() :new( oDlg:DrawingArea,, { 0, 24 }, aSize )
      oStatic:create()

      oSumatra := SumatraPDF() :New( oStatic )

      ii := 0
      aSize[ 2 ] := 24

      oPb2 := XbpPushButton() :new( oDlg:DrawingArea,, { 0, 0 }, aSize )
      oPb2:caption := "next"
      oPb2:create()
      oPb2:activate := { || LoadFile( oSumatra, cDir, aDir, @ii ) }

      SetAppfocus( oDlg )
      PostAppEvent( xbeP_Activate,,, oPb2 )

      nEvent := 0
      DO WHILE !lExit
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDDO

      oDlg:Destroy()

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure LoadFile()
*+
*+    Called from ( demo2.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE LoadFile( oSumatra, cDir, aDir, i )
LOCAL cLang      := "de"                                              // <- change to "en", "es" etc.
LOCAL nPage      := 0
LOCAL nZoom      := 1
LOCAL nView      := 1
LOCAL lBookmarks := .F.
LOCAL lToolbar   := .T.
LOCAL cPdfFile

   i ++
   IF i > LEN( aDir )
      i := 1
   ENDIF
   cPdfFile := cDir + aDir[ i ] [ 1 ]

   //    oSumatra:FileClose()
   oSumatra:FileOpen( cPdfFile, nPage, nZoom, nView, lBookmarks, lToolbar, cLang )

RETURN

*+--------------------------------------------------------------------
*+
*+    Function Pathonly()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Pathonly( cFull )
LOCAL cRet  := ""
LOCAL nPosi

   nPosi := RAT( "\", cFull )
   IF nPosi > 0
      cRet := SUBSTR( cFull, 1, nPosi )
   ENDIF

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Function Fileonly()
*+
*+    Called from ( demo2.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Fileonly( cFull )
LOCAL cRet  := ""
LOCAL nPosi

   nPosi := RAT( "\", cFull )
   IF nPosi > 0
      cRet := SUBSTR( cFull, nPosi + 1 )
   ENDIF

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Procedure DoResize()
*+
*+    Called from ( demo2.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoResize( aOldSize, aNewSize, oSelf, oSumatra )
LOCAL aSize, aChild, i, iMax

   IF aOldSize[ 1 ] == 0 .AND. aOldSize[ 2 ] == 0                     // is minimize
      RETURN                                                          //

   ELSEIF aNewSize[ 1 ] == 0 .OR. aNewSize[ 2 ] == 0                  // minimize
      RETURN                                                          //

   ELSEIF aNewSize[ 1 ] == aOldSize[ 1 ] .AND. aNewSize[ 2 ] == aOldSize[ 2 ]
      RETURN
   ENDIF

   aChild := oSelf:ChildList()
   iMax := LEN( aChild )
   FOR i := 1 TO iMax
      IF aChild[ i ] :isDerivedFrom( "XbpStatic" )
         aSize := ACLONE( aNewSize )
         aSize[ 2 ] -= 24
         aChild[ i ] :SetSize( aSize )
         oSumatra:FrameAdjust( aSize )

      ELSEIF aChild[ i ] :isDerivedFrom( "XbpPushbutton" )
         aSize := ACLONE( aNewSize )
         aSize[ 2 ] := 24
         aChild[ i ] :SetSize( aSize )
      ENDIF
   NEXT
RETURN

*+ EOF: DEMO2.PRG
